import * as ts from 'typescript';
import { TupleType } from '../../models/types/index';
import { ConverterTypeComponent, TypeConverter, TypeNodeConverter } from '../components';
import { Context } from '../context';
import { NamedTupleMember } from '../../models/types/tuple';
export declare class TupleConverter extends ConverterTypeComponent implements TypeConverter<ts.TypeReference, ts.TupleTypeNode> {
    supportsNode(_context: Context, node: ts.TupleTypeNode): boolean;
    supportsType(context: Context, type: ts.TypeReference): boolean;
    convertNode(context: Context, node: ts.TupleTypeNode): TupleType;
    convertType(context: Context, type: ts.TypeReference): TupleType;
}
export declare class NamedTupleMemberConverter extends ConverterTypeComponent implements TypeNodeConverter<ts.Type, ts.NamedTupleMember> {
    supportsNode(_context: Context, node: ts.Node): boolean;
    convertNode(context: Context, node: ts.NamedTupleMember): NamedTupleMember | undefined;
}
