"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypeArgumentsWithDefaults = exports.getTypeParametersOfType = void 0;
const ts = require("typescript");
function getTypeParametersOfType(type) {
    var _a, _b;
    const declarations = (_b = (_a = type.getSymbol()) === null || _a === void 0 ? void 0 : _a.getDeclarations()) !== null && _b !== void 0 ? _b : [];
    for (const declaration of declarations) {
        if ((ts.isClassDeclaration(declaration) || ts.isInterfaceDeclaration(declaration)) &&
            declaration.typeParameters) {
            return declaration.typeParameters;
        }
    }
    return [];
}
exports.getTypeParametersOfType = getTypeParametersOfType;
function getTypeArgumentsWithDefaults(typeParams, typeArguments) {
    if (!typeArguments || typeParams.length > typeArguments.length) {
        const typeArgumentsWithDefaults = new Array();
        for (let i = 0; i < typeParams.length; ++i) {
            if (typeArguments && typeArguments[i]) {
                typeArgumentsWithDefaults.push(typeArguments[i]);
            }
            else {
                const defaultType = typeParams[i].default;
                if (defaultType) {
                    typeArgumentsWithDefaults.push(defaultType);
                }
            }
        }
        return typeArgumentsWithDefaults;
    }
    return typeArguments;
}
exports.getTypeArgumentsWithDefaults = getTypeArgumentsWithDefaults;
//# sourceMappingURL=types.js.map