"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeOperatorType = void 0;
const abstract_1 = require("./abstract");
class TypeOperatorType extends abstract_1.Type {
    constructor(target, operator) {
        super();
        this.target = target;
        this.operator = operator;
        this.type = 'typeOperator';
    }
    clone() {
        return new TypeOperatorType(this.target.clone(), this.operator);
    }
    equals(type) {
        if (!(type instanceof TypeOperatorType)) {
            return false;
        }
        return type instanceof TypeOperatorType && type.operator === this.operator && type.target.equals(this.target);
    }
    toString() {
        return `${this.operator} ${this.target.toString()}`;
    }
}
exports.TypeOperatorType = TypeOperatorType;
//# sourceMappingURL=type-operator.js.map